; Copyright (c) 2007 Damian Yerrick
; 
; Permission is hereby granted, free of charge, to any person
; obtaining a copy of this software and associated documentation
; files (the "Software"), to deal in the Software without
; restriction, including without limitation the rights to use,
; copy, modify, merge, publish, distribute, sublicense, and/or sell
; copies of the Software, and to permit persons to whom the
; Software is furnished to do so, subject to the following
; conditions:
; 
; The above copyright notice and this permission notice shall be
; included in all copies or substantial portions of the Software.
; 
; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
; EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
; OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
; NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
; HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
; WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
; FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
; OTHER DEALINGS IN THE SOFTWARE.


.global dpcm_play

DPCM_RATE = $4010
DPCM_RAW = $4011
DPCM_START = $4012
DPCM_LEN = $4013
SND_CHN = $4015

.macro DPCM_DEF address, rate
  .byt <(address >> 6)
  .byt rate
.endmacro

.segment "DPCM"
.align 64
dpcm_00:

  .incbin "obj/nes/1bps.dmc"

.align 64
dpcm_end:

dpcm_table:
  DPCM_DEF dpcm_00, $0F
  DPCM_DEF dpcm_end, $0F

.segment "CODE"
;;
; Plays a DPCM sample.
; A: sample number
.proc dpcm_play
  asl a
  tax
  lda dpcm_table+1,x
  sta DPCM_RATE
  lda #$40
  sta DPCM_RAW
  lda dpcm_table,x
  sta DPCM_START
  eor #$3F
  clc
  adc dpcm_table+2,x
  asl a
  asl a
  ora #3
  sta DPCM_LEN
  lda #$0F
  sta SND_CHN
  lda #$1F
  sta SND_CHN
  rts
.endproc
